#Include This Once

%USEPBDECL=1
#Include Once "windows.inc"

Enum tBagTypes
	eString = 1
	eWString
	eStringZ
	eWStringZ
	eLong
	eDWord
	eWord
	eQuad
	eInteger
	eByte
	eExtended
	eDouble
	eSingle
	eCurrency
	eCurrencyX
	eType
End Enum

Type tBagEntry
	hashcode_ As Long           ' Hashcode for entry (0=Deleted)
	next_ As tBagEntry Ptr      ' next entries_
	key_ As Long                ' See BagTypes
End Type

Type tBag
	table_ As Long Ptr          ' Array of Pointers to entries_
	maxTable_ As Long           ' total # of slots in table_

	entries_ As tBagEntry Ptr   ' Array of bagEntries
	entryCount_ As Long         ' # of items in entries_
	maxEntries_ As Long         ' total # of slots in entries_

	freeCount_ As Long          ' # of removed items (count = high
	free_ As Long               ' first free entries_ offset (+1)

	collation_ As Byte Ptr      ' Pointer to binary collation table (String, WString, StringZ, WStringZ)
	type_ As Long               ' See BagTypes
	size_ As Long               ' Size of WStringZ, StringZ, Type
	dwords_ As Long             ' Size of type in dwords
	eSize_ As Long              ' Total size of each entry
End Type

AsmData caseInsensitiveAscii
	DB &h00, &h01, &h02, &h03, &h04, &h05, &h06, &h07, &h08, &h09, &h0A, &h0B, &h0C, &h0D, &h0E, &h0F
	DB &h10, &h11, &h12, &h13, &h14, &h15, &h16, &h17, &h18, &h19, &h1A, &h1B, &h1C, &h1D, &h1E, &h1F
	DB &h20, &h21, &h22, &h23, &h24, &h25, &h26, &h27, &h28, &h29, &h2A, &h2B, &h2C, &h2D, &h2E, &h2F
	DB &h30, &h31, &h32, &h33, &h34, &h35, &h36, &h37, &h38, &h39, &h3A, &h3B, &h3C, &h3D, &h3E, &h3F
	DB &h40, &h41, &h42, &h43, &h44, &h45, &h46, &h47, &h48, &h49, &h4A, &h4B, &h4C, &h4D, &h4E, &h4F
	DB &h50, &h51, &h52, &h53, &h54, &h55, &h56, &h57, &h58, &h59, &h5A, &h5B, &h5C, &h5D, &h5E, &h5F
	DB &h60, &h41, &h42, &h43, &h44, &h45, &h46, &h47, &h48, &h49, &h4A, &h4B, &h4C, &h4D, &h4E, &h4F
	DB &h50, &h51, &h52, &h53, &h54, &h55, &h56, &h57, &h58, &h59, &h5A, &h7B, &h7C, &h7D, &h7E, &h7F
	DB &h80, &h81, &h82, &h83, &h84, &h85, &h86, &h87, &h88, &h89, &h8A, &h8B, &h8C, &h8D, &h8E, &h8F
	DB &h90, &h91, &h92, &h93, &h94, &h95, &h96, &h97, &h98, &h99, &h8A, &h9B, &h8C, &h9D, &h8E, &h9F
	DB &hA0, &hA1, &hA2, &hA3, &hA4, &hA5, &hA6, &hA7, &hA8, &hA9, &hAA, &hAB, &hAC, &hAD, &hAE, &hAF
	DB &hB0, &hB1, &hB2, &hB3, &hB4, &hB5, &hB6, &hB7, &hB8, &hB9, &hBA, &hBB, &hBC, &hBD, &hBE, &hBF
	DB &hC0, &hC1, &hC2, &hC3, &hC4, &hC5, &hC6, &hC7, &hC8, &hC9, &hCA, &hCB, &hCC, &hCD, &hCE, &hCF
	DB &hD0, &hD1, &hD2, &hD3, &hD4, &hD5, &hD6, &hD7, &hD8, &hD9, &hDA, &hDB, &hDC, &hDD, &hDE, &hDF
	DB &hC0, &hC1, &hC2, &hC3, &hC4, &hC5, &hC6, &hC7, &hC8, &hC9, &hCA, &hCB, &hCC, &hCD, &hCE, &hCF
	DB &hD0, &hD1, &hD2, &hD3, &hD4, &hD5, &hD6, &hF7, &hD8, &hD9, &hDA, &hDB, &hDC, &hDD, &hDE, &h9F
End AsmData

AsmData caseSensitiveAscii
	DB &h00, &h01, &h02, &h03, &h04, &h05, &h06, &h07, &h08, &h09, &h0A, &h0B, &h0C, &h0D, &h0E, &h0F
	DB &h10, &h11, &h12, &h13, &h14, &h15, &h16, &h17, &h18, &h19, &h1A, &h1B, &h1C, &h1D, &h1E, &h1F
	DB &h20, &h21, &h22, &h23, &h24, &h25, &h26, &h27, &h28, &h29, &h2A, &h2B, &h2C, &h2D, &h2E, &h2F
	DB &h30, &h31, &h32, &h33, &h34, &h35, &h36, &h37, &h38, &h39, &h3A, &h3B, &h3C, &h3D, &h3E, &h3F
	DB &h40, &h41, &h42, &h43, &h44, &h45, &h46, &h47, &h48, &h49, &h4A, &h4B, &h4C, &h4D, &h4E, &h4F
	DB &h50, &h51, &h52, &h53, &h54, &h55, &h56, &h57, &h58, &h59, &h5A, &h5B, &h5C, &h5D, &h5E, &h5F
	DB &h60, &h61, &h62, &h63, &h64, &h65, &h66, &h67, &h68, &h69, &h6A, &h6B, &h6C, &h6D, &h6E, &h6F
	DB &h70, &h71, &h72, &h73, &h74, &h75, &h76, &h77, &h78, &h79, &h7A, &h7B, &h7C, &h7D, &h7E, &h7F
	DB &h80, &h81, &h82, &h83, &h84, &h85, &h86, &h87, &h88, &h89, &h8A, &h8B, &h8C, &h8D, &h8E, &h8F
	DB &h90, &h91, &h92, &h93, &h94, &h95, &h96, &h97, &h98, &h99, &h9A, &h9B, &h9C, &h9D, &h9E, &h9F
	DB &hA0, &hA1, &hA2, &hA3, &hA4, &hA5, &hA6, &hA7, &hA8, &hA9, &hAA, &hAB, &hAC, &hAD, &hAE, &hAF
	DB &hB0, &hB1, &hB2, &hB3, &hB4, &hB5, &hB6, &hB7, &hB8, &hB9, &hBA, &hBB, &hBC, &hBD, &hBE, &hBF
	DB &hC0, &hC1, &hC2, &hC3, &hC4, &hC5, &hC6, &hC7, &hC8, &hC9, &hCA, &hCB, &hCC, &hCD, &hCE, &hCF
	DB &hD0, &hD1, &hD2, &hD3, &hD4, &hD5, &hD6, &hD7, &hD8, &hD9, &hDA, &hDB, &hDC, &hDD, &hDE, &hDF
	DB &hE0, &hE1, &hE2, &hE3, &hE4, &hE5, &hE6, &hE7, &hE8, &hE9, &hEA, &hEB, &hEC, &hED, &hEE, &hEF
	DB &hF0, &hF1, &hF2, &hF3, &hF4, &hF5, &hF6, &hF7, &hF8, &hF9, &hFA, &hFB, &hFC, &hFD, &hFE, &hFF
End AsmData

' Previous: initial: 2477664281, multiply: 1647726497
%BAG_INITIAL =  2467198427   '930E75DB  10010011000011100111010111011011
%BAT_MULT =  1919826197   '726E3915  1110010011011100011100100010101
Function Bag_HashCode( obj As tBag, value As Dword ) As Long
	Local i, hc As Long
	Local sp1 As String Ptr
	Local wp1 As Word Ptr
	Local b1 As Byte Ptr
	Local p As Dword Ptr
	Local ws1 As WString Ptr
	Local sz1 As StringZ Ptr
	Local wz1 As WStringZ Ptr

	hc =  %BAG_INITIAL
	' Generate hash
	Select Case Const obj.type_
		Case %tBagTypes.eString:
			sp1 = value
			b1 = StrPtr( @sp1 )
			For i=0 To Len(@sp1) ' Including 0 on purpose
				hc += obj.@collation_[ @b1[i] ]
				hc *= %BAT_MULT
			Next

		Case %tBagTypes.eWString:
			ws1 = value
			wp1 = StrPtr( @ws1 )
			For i=0 To Len(@ws1) ' Including 0 on purpose
				hc += obj.@collation_[ @wp1[i] And 255 ]
				hc *= %BAT_MULT
			Next

		Case %tBagTypes.eStringZ:
			sz1 = value
			b1 = sz1
			For i=0 To obj.size_
				hc += obj.@collation_[ @b1[i] ]
				hc *= %BAT_MULT
				If IsFalse( @b1[i] ) Then Exit For
			Next

		Case %tBagTypes.eWStringZ:
			wz1 = value
			wp1 = wz1
			For i=0 To obj.size_
				hc += obj.@collation_[ @wp1[i] And 255 ]
				hc *= %BAT_MULT
				If IsFalse( @wp1[i] And 255 ) Then Exit For
			Next

		Case %tBagTypes.eByte:
			b1 = value
			hc += @b1
			hc *= %BAT_MULT

		Case %tBagTypes.eWord, %tBagTypes.eInteger
			wp1 = value
			hc += @wp1
			hc *= %BAT_MULT

		Case %tBagTypes.eExtended: ' 10 bytes... :(
			' two dwords and a word, 5 words, or 10 bytes...
			p = value
			wp1 = p + 8
			For i=0 To 1
				hc += @p[i]
				hc *= %BAT_MULT
			Next
			hc += CLng(@wp1)
			hc *= %BAT_MULT


		Case  %tBagTypes.eLong, %tBagTypes.eDWord, %tBagTypes.eQuad, _
					%tBagTypes.eDouble, %tBagTypes.eSingle, %tBagTypes.eCurrency, %tBagTypes.eCurrencyX, _
					%tBagTypes.eType:
			p = value
			For i=0 To obj.dwords_ - 1
				hc += @p[i]
				hc *= %BAT_MULT
			Next
	End Select

	Function = hc And &h7fffffff      ' Mask off high bit (make a positive number)
End Function

Sub Bag_Alloc( obj As Dword, bagType As Long, Optional ByVal collation As Dword, Optional ByVal memberSize As Long, Optional ByVal requestedCapacity As Long )
#Register None
	Static heap As Long
	If IsFalse(heap) Then heap = GetProcessHeap()
	obj = HeapAlloc( heap, %HEAP_ZERO_MEMORY, SizeOf( tBag ) )
	Bag_Init ByVal obj, bagType, collation, memberSize, requestedCapacity
End Sub

Sub Bag_Free( obj As Dword )
#Register None
	Local o As tBag Ptr
	Static heap As Long

	If IsFalse(heap) Then heap = GetProcessHeap()
	o = obj
	Bag_Release @o
	If obj Then HeapFree heap, 0, obj
	obj = 0
End Sub

Sub Bag_Init( obj As tBag, bagType As Long, Optional ByVal collation As Dword, Optional ByVal memberSize As Long, Optional ByVal requestedCapacity As Long )
#Register None
	Local sq As Quad
	Local se As Extended
	Local sc As Currency
	Local sx As CurrencyX
	Local ss As Single
	Local sd As Double
	Local si As Integer
	Local sb As Byte
	Local sl As Long
	Local i As Long
	If obj.entries_ Then Bag_Release obj
	If memberSize<1 Then memberSize=1 ' Minimum size
	obj.type_ = bagType
	obj.collation_ = collation

	' Init
	Select Case Const bagType
		Case %tBagTypes.eString:
			' Collation
			obj.size_ = -1 ' N/A for dynamic strings
			obj.eSize_ = SizeOf( tBagEntry )
			If obj.collation_=0 Then obj.collation_ = CodePtr( caseInsensitiveAscii )

		Case %tBagTypes.eWString:
			' Collation
			obj.size_ = -1 ' N/A for dynamic strings
			obj.eSize_ = SizeOf( tBagEntry )
			If obj.collation_=0 Then obj.collation_ = CodePtr( caseInsensitiveAscii )

		Case %tBagTypes.eStringZ:
			' Collation, specific size type!
			obj.size_ = memberSize
			obj.eSize_ = SizeOf( tBagEntry ) + obj.size_ - SizeOf(sl) + 1
			If obj.collation_=0 Then obj.collation_ = CodePtr( caseInsensitiveAscii )

		Case %tBagTypes.eWStringZ:
			' Collation, specific size type!
			obj.size_ = memberSize
			obj.eSize_ = SizeOf( tBagEntry ) + obj.size_ - SizeOf(sl) + 1
			If obj.collation_=0 Then obj.collation_ = CodePtr( caseInsensitiveAscii )

		Case %tBagTypes.eLong:
			obj.size_ = SizeOf( sl )
			obj.eSize_ = SizeOf( tBagEntry )

		Case %tBagTypes.eDWord:
			obj.size_ = SizeOf( sl )
			obj.eSize_ = SizeOf( tBagEntry )

		Case %tBagTypes.eWord:
			obj.size_ = SizeOf( si )
			obj.eSize_ = SizeOf( tBagEntry )

		Case %tBagTypes.eQuad:
			obj.size_ = SizeOf( sq )
			obj.eSize_ = SizeOf( tBagEntry ) + SizeOf(sq) - SizeOf(i)

		Case %tBagTypes.eInteger:
			obj.size_ = SizeOf( si )
			obj.eSize_ = SizeOf( tBagEntry )

		Case %tBagTypes.eByte:
			obj.size_ = SizeOf( sb )
			obj.eSize_ = SizeOf( tBagEntry )

		Case %tBagTypes.eExtended:
			obj.size_ = SizeOf( se )
			obj.eSize_ = SizeOf( tBagEntry ) + SizeOf(se) - SizeOf(i)

		Case %tBagTypes.eDouble:
			obj.size_ = SizeOf( sd )
			obj.eSize_ = SizeOf( tBagEntry ) + SizeOf(sd) - SizeOf(i)

		Case %tBagTypes.eSingle:
			obj.size_ = SizeOf( ss )
			obj.eSize_ = SizeOf( tBagEntry ) + SizeOf(ss) - SizeOf(i)

		Case %tBagTypes.eCurrency:
			obj.size_ = SizeOf( sc )
			obj.eSize_ = SizeOf( tBagEntry ) + SizeOf(sc) - SizeOf(i)

		Case %tBagTypes.eCurrencyX:
			obj.size_ = SizeOf( sx )
			obj.eSize_ = SizeOf( tBagEntry ) + SizeOf(sx) - SizeOf(i)

		Case %tBagTypes.eType:
			' Specific size type!
			obj.size_ = memberSize
			obj.eSize_ = SizeOf( tBagEntry ) + obj.size_ - SizeOf(i)
	End Select

	obj.eSize_ = (obj.eSize_ + 3) And -4
	obj.dwords_ = (obj.size_ + 3) And -4
	Shift Right obj.dwords_, 2

	If requestedCapacity>0 Then Bag_Expand obj, requestedCapacity
End Sub

Sub Bag_Expand( obj As tBag, Optional ByVal requestedCapacity As Long )
#Register None
	Local e As tBagEntry Ptr
	Local index As Long
	Local hc, i, entryCount, tableCount, memSize, entrySize, tableSize As Long
	Static heap As Long

	If requestedCapacity=0 Then requestedCapacity=obj.maxTable_
	If IsFalse(heap) Then heap = GetProcessHeap()
	tableCount = BagGetNextCollectionSize( requestedCapacity )
	entryCount = CLng( tableCount * .75! )
	'Use the following if you make small increases to the tableCount
	'If entryCount<=obj.entryCount_ Then entryCount = obj.entryCount_+1
	tableSize = tableCount * SizeOf( i )
	entrySize = entryCount * obj.eSize_
	memSize = tableSize + entrySize

	' Single allocation: Layout Entries followed by hashtable
	' Reason: Existing entries need to be retained while new values and the hashtable need to be zero'ed.
	If obj.entries_ Then
		obj.entries_ = HeapReAlloc( heap, 0, obj.entries_, memSize )
		If IsFalse( obj.entries_ ) Then
			? "Failed allocation"
			End
		End If
		' Zero bag entries after active ones and all of hashtable
		Local sz, ofs As Long
		sz = (entryCount-obj.entryCount_) * obj.eSize_
		ofs = obj.entryCount_ * obj.eSize_

		Memory Fill obj.entries_+ofs, tableSize+sz, Byte 0
	Else
		obj.entries_ = HeapAlloc( heap, %HEAP_ZERO_MEMORY, memSize )
		If IsFalse( obj.entries_ ) Then
			? "Failed allocation"
			End
		End If
	End If
	obj.table_ = obj.entries_ + entrySize

	obj.maxTable_ = tableCount
	obj.maxEntries_ = entryCount

	' Redistribute hashes
	e = obj.entries_
	For i = 0 To obj.entryCount_ - 1
		If @e.hashCode_ Then
			hc = @e.hashCode_
			index = hc Mod obj.maxTable_

			@e.next_ = obj.@table_[ index ]
			obj.@table_[ index ] = e
		End If
		e += obj.eSize_
	Next
End Sub

Function Bag_IndexOf( obj As tBag, ByVal value As Dword ) As Long
#Register None
	Local i, c, hc, index As Long
	Local e As tBagEntry Ptr

	If IsFalse( obj.table_ ) Then Function=-1: Exit Function

	hc = Bag_HashCode( obj, value )
	index = hc Mod obj.maxTable_

	e = obj.@table_[ index ]
	While e
		If @e.hashCode_ = hc Then
			' Compares
			Select Case Const obj.type_
				Case %tBagTypes.eString:
					Local sp1, sp2 As String Ptr
					Local b1, b2 As Byte Ptr
					sp1 = VarPtr( @e.key_ )
					sp2 = value
					b1 = StrPtr( @sp1 )
					b2 = StrPtr( @sp2 )
					For i=0 To Len(@sp1) ' Including 0 on purpse
						If obj.@collation_[ @b1[i] ] <> obj.@collation_[ @b2[i] ] Then c=0: Exit Select
					Next
					c = -1

				Case %tBagTypes.eWString:
					Local ws1, ws2 As WString Ptr
					Local wp1, wp2 As Word Ptr
					ws1 = VarPtr( @e.key_ )
					ws2 = value
					wp1 = StrPtr( @ws1 )
					wp2 = StrPtr( @ws2 )
					For i=0 To Len(@ws1) ' Including 0 on purpse
						If obj.@collation_[ @wp1[i] And 255 ] <> obj.@collation_[ @wp2[i] And 255 ] Then c=0: Exit Select
					Next
					c = -1

				Case %tBagTypes.eStringZ:
					Local sz1, sz2 As StringZ Ptr
					sz1 = VarPtr( @e.key_ )
					sz2 = value
					b1 = sz1
					b2 = sz2
					' Strings might be < obj.size_ however:
					' either the values are = up to an including both of their 0 bytes, in which case @b1[i]=0 will exit
					' or they differ, either because one is longer than the other or because other bytes differ, these will all hit the c=0 case.
					For i=0 To obj.size_
						If obj.@collation_[ @b1[i] ] <> obj.@collation_[ @b2[i] ] Then c=0: Exit Select
						If @b1[i]=0  Then Exit For
					Next
					c = -1

				Case %tBagTypes.eWStringZ:
					Local wz1, wz2 As WStringZ Ptr
					wz1 = VarPtr( @e.key_ )
					wz2 = value
					b1 = wz1
					b2 = wz2
					' Strings might be < obj.size_ however:
					' either the values are = up to an including both of their 0 bytes, in which case @b1[i]=0 will exit
					' or they differ, either because one is longer than the other or because other bytes differ, these will all hit the c=0 case.
					For i=0 To obj.size_
						If obj.@collation_[ @b1[i] And 255 ] <> obj.@collation_[ @b2[i] And 255 ] Then c=0: Exit Select
						If IsFalse( @b1[i] And 255 ) Then Exit For
					Next
					c = -1

				Case %tBagTypes.eByte:
					' 1 byte
					b1 = VarPtr( @e.key_ )
					b2 = value
					c = IIf&( @b1=@b2, -1, 0 )

				Case %tBagTypes.eInteger, %tBagTypes.eWord:
					' 2 bytes
					wp1 = VarPtr( @e.key_ )
					wp2 = value
					c = IIf&( @wp1=@wp2, -1, 0 )

				Case %tBagTypes.eExtended: ' 10 bytes... :(
					' two dwords and a word, 5 words, or 10 bytes...
					Local dw1, dw2 As Dword Ptr
					dw1 = VarPtr( @e.key_ )
					dw2 = value
					If @dw1[0] <> @dw2[0] Then c=0: Exit Select
					If @dw1[1] <> @dw2[1] Then c=0: Exit Select
					wp1 = dw1+8
					wp2 = dw2+8
					If @wp1 <> @wp2 Then c=0: Exit Select
					c = -1

				Case  %tBagTypes.eLong, %tBagTypes.eDWord, %tBagTypes.eQuad, _
							%tBagTypes.eDouble, %tBagTypes.eSingle, %tBagTypes.eCurrency, %tBagTypes.eCurrencyX, _
							%tBagTypes.eType:
					' 4 bytes+
					dw1 = VarPtr( @e.key_ )
					dw2 = value
					For i=0 To obj.dwords_ - 1
						If @dw1[i] <> @dw2[i] Then c=0: Exit Select
					Next
					c = -1

				'Alternative: Can use object type pointers directly if bit comparisons don't work
				'case %tBagTypes.eSingle:
				'  s1 = VarPtr( @e.key_ )
				'  s2 = value
				'  c = (@s1=@s2)
			End Select
			If c Then
				Function = (e - obj.entries_) \ obj.eSize_
				Exit Function
			End If
		End If
		e = @e.next_
	Wend
	Function = -1
	Exit Function
End Function

Function Bag_Add( obj As tBag, ByVal value As Dword ) As Long
#Register None
	Local i, index, hc As Long
	Local e As tBagEntry Ptr
	Local sp As String Ptr


	index = Bag_IndexOf( obj, value )
	If index>-1 Then Function = -1: Exit Function

	If obj.free_ Then
		' Use freed items first
		e = obj.free_
		obj.free_ = @e.next_
		Decr obj.freeCount_
	Else
		If obj.entryCount_ >= obj.maxEntries_ Then
			Bag_Expand obj
		End If
		If IsFalse( obj.table_ ) Or IsFalse( obj.entries_ ) Then
			? "Alloc failed"
			End
		End If
		e = obj.entries_ + (obj.entryCount_ * obj.eSize_)
		Incr obj.entryCount_
	End If

	' Assignment
	Select Case Const obj.type_
		Case %tBagTypes.eString:
			Local sp1, sp2 As String Ptr
			sp1 = VarPtr( @e.key_ )
			sp2 = value
			@sp1 = @sp2

		Case %tBagTypes.eWString:
			Local ws1, ws2 As WString Ptr
			ws1 = VarPtr( @e.key_ )
			ws2 = value
			@ws1 = @ws2

		Case %tBagTypes.eStringZ:
			Local sz1, sz2 As StringZ Ptr
			sz1 = VarPtr( @e.key_ )
			sz2 = value
			@sz1 = Left$( @sz2, obj.size_ )

		Case %tBagTypes.eWStringZ:
			Local wz1, wz2 As WStringZ Ptr
			wz1 = VarPtr( @e.key_ )
			wz2 = value
			@wz1 = Left$( @wz2, obj.size_ )

		Case  %tBagTypes.eByte:
			' 1 byte
			Local bp1, bp2 As Dword Ptr
			bp1 = VarPtr( @e.key_ )
			bp2 = value
			@bp1 = @bp2

		Case  %tBagTypes.eWord, %tBagTypes.eInteger
			' 2 bytes
			Local wp1, wp2 As Dword Ptr
			wp1 = VarPtr( @e.key_ )
			wp2 = value
			@wp1 = @wp2

		Case %tBagTypes.eExtended: ' 10 bytes... :(
			' two dwords and a word, 5 words, or 10 bytes...
			Memory Copy value, VarPtr( @e.key_ ), 10
			Local dw1, dw2 As Dword Ptr
'      dw1 = VarPtr( @e.key_ )
'      dw2 = value
'      wp1 = dw1 + 8
'      wp2 = dw2 + 8
'      @dw1[0] = @dw2[0]
'      @dw1[1] = @dw2[1]
'      @wp1 = @wp2

		Case  %tBagTypes.eLong, %tBagTypes.eDWord, %tBagTypes.eQuad,  _
					%tBagTypes.eDouble, %tBagTypes.eSingle, %tBagTypes.eCurrency, %tBagTypes.eCurrencyX, _
					%tBagTypes.eType:
			' 4 bytes+
			dw1 = VarPtr( @e.key_ )
			dw2 = value
			For i=0 To obj.dwords_ - 1
				@dw1[i] = @dw2[i]
			Next
	End Select

	hc = Bag_HashCode( obj, value )
	index = hc Mod obj.maxTable_

	@e.hashCode_ = hc

	@e.next_ = obj.@table_[ index ]   ' 1-n, or 0 if no next
	obj.@table_[ index ] = e

	Function = (e - obj.entries_) \ obj.eSize_
End Function

' Empty the bag
Sub Bag_Release( obj As tBag, Optional ByVal requestedCapacity As Long )
#Register None
	Register i As Long
	Static heap As Long
	Local sp As String Ptr
	Local e As tBagEntry Ptr

	If obj.entries_ Then
		If IsFalse(heap) Then heap = GetProcessHeap()
		e = obj.entries_
		' Release memory
		Select Case Const obj.type_
			Case %tBagTypes.eString:
				Local sp1 As String Ptr
				For i=0 To obj.entryCount_- 1
					sp1 = VarPtr( @e.key_ )
					@sp1 = ""
					e += obj.eSize_
				Next

			Case %tBagTypes.eWString:
				Local ws1 As WString Ptr
				For i=0 To obj.entryCount_- 1
					ws1 = VarPtr( @e.key_ )
					@ws1 = ""
					e += obj.eSize_
				Next

			'Case  %tBagTypes.eStringZ, %tBagTypes.eWStringZ, %tBagTypes.eLong, %tBagTypes.eDWord,      _
			'      %tBagTypes.eWord, %tBagTypes.eQuad, %tBagTypes.eInteger, %tBagTypes.eByte,           _
			'      %tBagTypes.eExtended, %tBagTypes.eDouble, %tBagTypes.eSingle, %tBagTypes.eCurrency,  _
			'      %tBagTypes.eCurrencyX, %tBagTypes.eType:
				' Nothing to do!  Just sayin...

		End Select
		HeapFree heap, 0, obj.entries_

		obj.table_      = 0
		obj.maxTable_   = 0
		obj.entries_    = 0
		obj.entryCount_ = 0
		obj.maxEntries_ = 0
		obj.freeCount_  = 0
		obj.free_       = 0
	End If
	If requestedCapacity>0 Then
		Bag_Expand obj, requestedCapacity
	End If
End Sub

' Number of items in the bag
Function Bag_Count( obj As tBag ) As Long
	Function = obj.entryCount_ - obj.freeCount_
End Function

' Max Index # can go
Function Bag_MaxEntry( obj As tBag ) As Long
	Function = obj.entryCount_
End Function

Function Bag_Remove ( obj As tBag, ByVal value As Dword ) As Long
	Function = Bag_RemoveAt( obj, Bag_IndexOf( obj, value ) )
End Function

Function Bag_RemoveAt ( obj As tBag, ByVal i As Long ) As Long
#Register None
	Register index As Long
	Register j As Long
	Local hc As Long
	Local e, f As tBagEntry Ptr

	If i<0 Or i>=obj.entryCount_ Then  Exit Function   ' Out of bounds
	e = obj.entries_ + ( i * obj.eSize_ )
	If IsFalse( @e.hashCode_ ) Then Exit Function ' Already deleted

	hc = @e.hashCode_
	index = (hc Mod obj.maxTable_)

	If obj.@table_[ index ] = e Then
		obj.@table_[ index ] = @e.next_: ' First item in list
	Else
		' Have prior entry's next point past the entry to remove
		f = obj.@table_[ index ]
		Do While f
			If @f.next_ = e Then
				@f.next_ = @e.next_
				Exit Loop
			End If
			f = @f.next_
		Loop
	End If
	' Reuse the free entries (Leaving release alone, we'll release it when reusing or clearing)
	@e.hashCode_ = 0
	@e.next_ = obj.free_
	obj.free_ = e
	Incr obj.freeCount_
	Function =-1
End Function

Sub Bag_Clear( obj As tBag )
	Local i As Long
	Local e, n As tBagEntry Ptr

	If IsFalse( obj.entryCount_ ) Then Exit Sub
	e = obj.entries_
	obj.free_ = e
	For i=0 To obj.entryCount_-2
		@e.next_ = e + obj.eSize_
		@e.hashCode_ = 0
		e = @e.next_
	Next
	@e.next_ = 0
	@e.hashCode_ = 0
	obj.freeCount_ = obj.entryCount_
	If obj.maxTable_ Then Memory Fill obj.table_, obj.maxTable_*SizeOf(i), Byte 0
End Sub

 ' Get an item by index, returns empty string if out of bounds
Sub Bag_Item( obj As tBag, ByVal index As Long, v As Dword )
	Local sp As String Ptr
	Local e As tBagEntry Ptr
	If index>=0 And index<obj.entryCount_ Then
		e = obj.entries_ + ( index * obj.eSize_ )
		If @e.hashCode_ Then v = VarPtr( @e.key_ ) Else v = 0
	Else
		v = 0
	End If
End Sub

Function BagGetNextCollectionSize( ByVal tableCount As Long ) As Long
	Static vPrimes() As Long
	Static vInit As Long
	Local i As Long

	If Not vInit Then
		ReDim vPrimes(25)
		Array Assign vPrimes() = _
						53, 97, 193, 389, 769, 1543, 3079, 6151, 12289 _
						, 24593, 49157, 98317, 196613, 393241, 786433 _
						, 1572869, 3145739, 6291469, 12582917, 25165843 _
						, 50331653, 100663319, 201326611, 402653189 _
						, 805306457, 1610612741

'     16,  32,  64,  128,  256,  512,  1024,  2048,                _
'     4096,  8192,  16384,  32768,  65536,  131072,  262144,       _
'     524288,  1048576,  2097152,  4194304,  8388608,  16777216,   _
'     33554432,  67108864,  134217728,  268435456,  536870912,     _
'     1073741824,  2147483648

		vInit = -1
	End If

	Incr tableCount
	For i=0 To 25
		If vPrimes(i)>=tableCount Then
			Function = vPrimes(i)
			Exit Function
		End If
	Next

	Function = vPrimes(25)
End Function
