#Compiler PBWin 10, PBCC 6
#Compile Exe
#Dim All
#Debug Display On
#If %Def( %PB_CC32 )
#Console Off
#EndIf

#Include "bag.inc"
#Include "console.inc"

Function PBMain () As Long
	Local a As tBag
	ConInit
	ConCls(9,15)
	Interactive a
	ConClose
End Function

Sub Interactive( b As tBag )
	Local i As Long
	Local hWin As Dword
	Local cmd, a As String
	Local j, cnt, dup, ff As Long
	Local v As String
	Local w() As String

	Bag_Init b, %tBagTypes.eString, CodePtr( caseSensitiveAscii )
	While -1
		ConWriteln ""
		ConWrite "A)dd F)ind I)ndex R)emove C)lear L)oad H)eader S)tats B)uckets E)ntries G)enerate E(x)it> "
		cmd = ConLineInput
		ConWriteln ""
		Select Case UCase$(Left$(cmd,1))
			Case "G"
				ConWrite "N)umber R)andom >"
				a = ConLineInput
				ConWriteln ""
				Select Case UCase$(Left$( a,1))
					Case "N"
						ConWrite "Up to> "
						a = ConLineInput
						ConWriteln ""
						If Val(a)>0 Then
							Bag_Release b
							For i=1 To Val(a)
								v = Format$(i)
								Bag_Add( b, ByRef v)
							Next
						End If
					Case "R"
						ConWrite "# of entries> "
						a = ConLineInput
						ConWriteln ""
						cnt = Val( a )
						If cnt<1 Then Iterate Loop
						ConWrite "Length> "
						a = ConLineInput
						ConWriteln ""
						j = Val( a )
						If j<1 Then Iterate Loop
						For i=0 To cnt
							v = ""
							While Len(v)<j
								v += Mid$( "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789", Rnd(1, 36), 1 )
							Wend
							Bag_Add b, ByRef  v
						Next
				End Select

			Case "A"
				ConWrite "value> "
				a = ConLineInput
				ConWriteln ""

				If Bag_Add( b, ByRef  a ) Then
					ConWriteln "Added item"
				Else
					ConWriteln "Failed, already exists"
				End If
			Case "L"
				Conwrite "File> "
				a = ConLineInput
				ConWriteln ""
				If Dir$(a)="" Then ConWriteln "File not found": Iterate Loop
				ff = FreeFile
				Open a For Binary As #ff
				Get$ #ff, Lof(#ff), v
				Close #ff
				i = ParseCount( v, $CrLf )
				ReDim w(i-1)
				Parse v, w(), $CrLf
				cnt=0
				dup=0
				For ff=0 To i-1
					If w(ff)="" Then Iterate For
					If Bag_Add( b, ByRef w(ff) ) Then
						Incr cnt
					Else
						Incr dup
					End If
				Next
				ConWrite "Added "
				ConWriteln Format$(cnt, "#,##0")
				ConWrite "Dups not added "
				ConWriteln Format$(dup, "#,##0")
			Case "C"
				Bag_Release b
				Bag_Dump_Header b
			Case "H"
				Bag_Dump_Header b
			Case "B"
				Bag_Dump_Buckets b
			Case "E"
				Bag_Dump_Entries b
			Case "S"
				Bag_Dump_Stats b
			Case "R"
				ConWrite "Remove by V)alue or I)ndex> "
				a = ConLineInput
				ConWriteln ""
				Select Case UCase$(Left$(a,1))
					Case "V"
						ConWrite "value> "
						a = ConLineInput
						ConWriteln ""
						If Bag_Remove( b, ByRef a ) Then
							ConWriteln "Suceeded"
						Else
							ConWriteln "Failed"
						End If
					Case "I"
						ConWrite "index (1-"
						ConWrite Format$(b.entryCount_)
						ConWrite ")>"
						a = ConLineInput
						ConWriteln ""
						i = Val(a)
						If Bag_RemoveAt( b, i-1 ) Then
							ConWriteln "Suceeded"
						Else
							ConWriteln "Failed"
						End If
					Case Else
						ConWriteln "Invalid selection"
				End Select
			Case "I"
				ConWrite "value> "
				a = ConLineInput
				ConWriteln ""
				i = Bag_IndexOf( b, ByRef a )
				If i<0 Then
					ConWriteLn "Missing"
				Else
					ConWrite "Found @ "
					ConWriteln Format$(i+1)
				End If

			Case "F"
				ConWrite "value> "
				a = ConLineInput
				ConWriteln ""

				If Bag_IndexOf( b, ByRef a )>-1 Then
					ConWrite "Found"
				Else
					ConWriteln "Missing"
				End If

			Case "X"
				Exit Loop
		End Select
	Wend
End Sub

Sub Bag_Dump_Header( obj As tBag )
	Local i, cnt As Long

	ConCls(9,15)
	ConWriteln "table_:..... " + Right$( "00000000" + Hex$( obj.table_ ), 8 )
	ConWriteln "entries_:... " + Right$( "00000000" + Hex$( obj.entries_ ), 8 )
	ConWriteln "entry slots: " + Format$( obj.entryCount_ )
	ConWriteln "# free:..... " + Format$( obj.freeCount_ )
	ConWriteln "count....... " + Format$( Bag_Count( obj ) )
	ConWriteln "max table:.. " + Format$( obj.maxTable_ )
	ConWriteln "entryCount_: " + Format$( obj.entryCount_ )
	ConWriteln "first free:. " + Right$( "00000000" + Hex$( obj.free_ ), 8 )
End Sub

Sub Bag_Dump_Buckets( obj As tBag )
	Local i, s, w As Long
	Local a, ifmt, bfmt As String
	ConCls(9,15)
	ConWriteln "Buckets"
	ConWrite "A)ll buckets or P)opulated? (a)>"
	a = ConLineInput
	ConWriteln ""
	i = obj.maxTable_ + 1
	While i
		ifmt+="0"
		i \= 10
	Wend

	s = ConWidth() \ (5 + Len(ifmt)+ 8)
	a=Left$( UCase$( a ), 1 )
	For i=0 To obj.maxTable_-1
		If a="P" And obj.@table_[i]=0 Then Iterate For
		If w And (w Mod s=0) Then ConWriteln ""
		w += 1
		ConWrite "("
		ConWrite Format$(i+1, ifmt)
		ConWrite ", "
		ConWrite Right$("00000000" + Hex$( obj.@table_[i] ), 8 )
		ConWrite ") "
	Next
End Sub

Sub Bag_Dump_Stats( obj As tBag )
	Local chainCount, maxChainLength, totalChainLength, cnt As Long
	Local i, n As Long
	Local e, j As tBagEntry Ptr
	ConCls(9,15)
	ConWriteln "Stats"
	For i=0 To obj.maxTable_-1
		e = obj.@table_[i]
		If IsFalse(e) Then Iterate For
		If @e.next_ Then chainCount+=1
		e = @e.next_
		cnt=0
		While e
			Incr cnt
			Incr totalChainLength
			e = @e.next_
		Wend
		If cnt>0 Then maxChainLength=Max( maxChainLength, cnt )
	Next
	ConWriteln "chains:.............. " + Format$( chainCount )
	ConWriteln "Max chain length:.... " + Format$( maxChainLength )
	ConWriteln "Total chain length:.. " + Format$( totalChainLength )
	ConWriteln "Average chain length: " + Format$( totalChainLength / CDbl(chainCount), "#,##0.00" )
End Sub

Sub Bag_Dump_Entries( obj As tBag )
	Local chainCount, maxChainLength, totalChainLength, cnt As Long
	Local i, j As Long
	Local e As tBagEntry Ptr
	Local sp As String Ptr
	ConCls(9,15)
	ConWriteln "String Entries"
	For i=0 To obj.entryCount_-1
		If obj. @entries_[i].hashCode_=0 Then
			ConWrite RSet$( Format$(i+1), 4)
			conWriteln ") Deleted"
			Iterate For
		End If
		e = VarPtr( obj.@entries_[i] )
		ConWrite RSet$( Format$(i+1), 4)
		ConWrite ") addr="
		ConWrite Right$("00000000" + Hex$( e ), 8)
		ConWrite ", hc="
		ConWrite Right$("00000000" + Hex$( @e.hashcode_ ), 8)
		ConWrite ", next="
		ConWrite Right$("00000000" + Hex$( @e.next_ ), 8)
		Local v As String
		Bag_Item( obj, i, sp )
		ConWrite ", key="
		ConWriteln @sp
	Next
End Sub
