#Include This Once

'==============================================
' Super simple console routines
'==============================================
Global ConStdOut As Dword
Global ConStdIn As Dword
Global ConAttached As Long
Global fdwOldMode As Dword

Sub ConInit()
	Local fdwMode As Dword
	'? If I use Jose's includes, input doesn't work this way
	'  If I use PB's includes it works fine (other than the exit where I have to press enter to get a real command prompt)
	'If AttachConsole( %ATTACH_PARENT_PROCESS ) = 0 Then
		AllocConsole()
	'Else
	'  conattached = 1
	'End If
	ConStdOut = GetStdHandle(%STD_OUTPUT_HANDLE)
	ConStdIn = GetStdHandle(%STD_INPUT_HANDLE)
	GetConsoleMode ConStdIn, fdwOldMode
	fdwMode = %ENABLE_WINDOW_INPUT And %ENABLE_ECHO_INPUT And %ENABLE_LINE_INPUT
	SetConsoleMode( ConStdIn, fdwMode)

	If conattached Then
		ConWriteln ""
	End If
End Sub

Sub ConClose( Optional ByVal waitOnExit As Long )
	Local e As INPUT_RECORD
	Local r As Long

	SetConsoleMode ConStdIn, fdwOldMode

	If conattached Then
		e.EventType = %KEY_EVENT
		e.KeyEvent.bKeyDown = 1
		e.KeyEvent.wRepeatCount = 1
		e.KeyEvent.wVirtualKeyCode = %VK_RETURN
		e.KeyEvent.wVirtualScanCode = VkKeyScan(%VK_RETURN)
#If %Def($JRS_HEADERS_VERSION)
		e.KeyEvent.AsciiChar = 13
#Else
		e.KeyEvent.AsciiChar = Chr$( 13 )
#EndIf
		WriteConsoleInput( ConStdIn, ByRef e, 1, r )

		e.KeyEvent.bKeyDown = 0
		WriteConsoleInput( ConStdIn, ByRef e, 1, r )
		FreeConsole
	ElseIf waitOnExit Then
		ConWriteln "<press any enter to exit>"
		ConLineInput
	End If
End Sub

Sub ConDiscardInput()
	FlushConsoleInputBuffer ConStdIn
End Sub

Function ConGetch() As Byte
	Local r As Dword
	Local buf As StringZ*2
	Local b As Byte

	ReadFile( ConStdIn, ByRef buf, 1, r, ByVal 0 )

	Function = Asc( buf )
End Function

Function ConLineInput() As String
	Local ch As Byte
	Local v As String
	Do
		ch = conGetch()
		Select Case Const ch
			Case 13: Exit Loop
			Case 8: If v<>"" Then v=Left$( v, Len(v)-1 ): ConWrite Chr$( ch ): ConWrite " ": ConWrite Chr$( ch )
			Case Else
				If ch>=32 And ch<128 Then v += Chr$( ch )
				ConWrite Chr$( ch )
		End Select
	Loop
	Function = v
End Function

Sub ConWrite( msg As String )
	Local w As Long
	WriteConsole( ConStdOut, ByVal StrPtr( msg ), Len(msg ), w, 0 )
End Sub

Sub ConWriteln( msg As String )
	ConWrite( msg )
	ConWrite( $CrLf )
End Sub

Sub ConGetCell( r As Long, c As Long )
	Local v As CONSOLE_SCREEN_BUFFER_INFO
	GetConsoleScreenBufferInfo ConStdOut, v
	c = v.dwCursorPosition.x
	r = v.dwCursorPosition.y
End Sub

Sub ConSetCell( ByVal r As Long, ByVal c As Long )
	SetConsoleCursorPosition ConStdOut, Mak(Dword, c, r )
End Sub

Sub ConColor( ByVal fg As Long, ByVal bg As Long )
	Shift Left bg, 4
	fg Or= bg
	SetConsoleTextAttribute ConStdOut, fg
End Sub

Function ConWidth() As Long
		Local buf As CONSOLE_SCREEN_BUFFER_INFO
		GetConsoleScreenBufferInfo ConStdOut, buf
		Function = buf.dwSize.X
End Function

Sub ConCls( ByVal fg As Long, ByVal bg As Long )
		Local buf As CONSOLE_SCREEN_BUFFER_INFO
		Local conSize, written As Dword
		Local p As Dword

		GetConsoleScreenBufferInfo ConStdOut, buf
		conSize = buf.dwSize.X * buf.dwSize.Y

		FillConsoleOutputCharacter ConStdOut, 32, conSize, p, written

		Shift Left bg, 4
		fg Or= bg
		SetConsoleTextAttribute ConStdOut, fg

		FillConsoleOutputAttribute ConStdOut, fg, conSize, p, written

		ConSetCell 0, 0
End Sub

'==============================================
