#Compiler PBWin 10, PBCC 6
#Compile Exe
#Dim All
#Optimize Speed
#If %Def( %PB_CC32 )
#Console Off
#EndIf

#Include "..\bag.inc"
#Include "..\console.inc"

%COUNT = 1000000
' Comment out the line below to use a local (stack based) stringbag variable
' With it uncommented, it will use a dynamically allocated stringbag
%DYNAMIC = 1

Function PBMain () As Long
	ConInit
	ConCls 3, 0
#If %Def( %DYNAMIC )
	Local a As tBag Ptr
	Bag_Alloc a, %tBagTypes.eWStringZ, CodePtr( caseSensitiveAscii ), 14, %COUNT
	Test @a
	Bag_Free a
#Else
	Local a As tBag
	Test a
#EndIf
	ConClose -1
End Function

Sub Test( b As tBag )
	Local i, j As Long
	Local hWin As Dword
	Local qe, q1, q2, q3, q4, q5, q6, q7, q8, q9, q10, q11, q12, tot As Quad
	Local s, e As Single
	Local sp As WStringZ Pointer
	Local v(), u As WStringZ*14
	ReDim v(%COUNT)

	ConWrite "Running "
#If %Def( %DYNAMIC )
	ConWrite "dynamic "
#Else
	ConWrite "local "
#EndIf
	ConWriteln "test..."
	ConWriteln "Formatting..."
	Tix q1
	For i=1 To %COUNT
		v(i) = Format$( i )
	Next
	Tix End q1

	Tix tot
	s = Timer

	ConWriteln "Initing..."
	Bag_Init b, %tBagTypes.eWStringZ, CodePtr( caseSensitiveAscii ), 14, %COUNT

	ConWriteln "Adding..."
	Tix q2
	For i=1 To %COUNT
		Bag_Add b, ByRef v(i)
	Next
	Tix End q2

	ConWriteln "Item..."
	Tix q3
	For i=0 To Bag_Count(b)-1
		Bag_Item b, i, sp
		If sp And @sp<>v(i+1) Then ConWriteln Using$( "Item # is &", i, u )
	Next
	Tix End q3

	ConWriteln "IndexOf..."
	Tix q4
	For i=1 To %COUNT
		j = Bag_IndexOf( b, ByRef v(i) )
		If j<>i-1 Then
			ConWriteln Using$( "IndexOf & = #, not #,", v(i), j, i-1 )
		End If
	Next
	Tix End q4

	ConWriteln "Find..."
	Tix q5
	For i=1 To %COUNT
		If Bag_IndexOf( b, ByRef v(i) ) <0 Then ConWriteln "Find missed '" + Format$(i) + "'"
	Next
	Tix End q5

	ConWriteln "RemoveAt..."
	Tix q6
	For i=0 To %COUNT-1
		Bag_RemoveAt( b, i )
	Next
	Tix End q6


	ConWriteln "Adding..."
	Tix q7
	For i=1 To %COUNT
		Bag_Add b, ByRef v(i)
	Next
	Tix End q7

	ConWriteln "RemoveAll..."
	Tix q8
	Bag_Clear b
	Tix End q8

	ConWriteln "Clear..."
	Tix q9
	Bag_Release b, %COUNT
	Tix End q9

	ConWriteln "Adding..."
	Tix q10
	For i=1 To %COUNT
		Bag_Add b, ByRef v(i)
	Next
	Tix End q10

	ConWriteln "Remove..."
	Tix q11
	For i=1 To %COUNT
		Bag_Remove b, ByRef v(i)
	Next
	Tix End q11

	ConWriteln "Clear..."
	Tix q12
	Bag_Release b
	Tix End q12

	Tix End tot

	e = Timer
	Local tixPerSec As Single
	Local tests As Long
	tests = 11
	tixPerSec = (tot) / (e-s)
	Open "TimeWStringZS.txt" For Output As #1
	Print #1,  "WStringZS Finished";    $Tab; %COUNT; $Tab; "Tix/Op"; $Tab; "Ops/Sec"
	Print #1,  "Format";      $Tab; q1;   $Tab; q1/%COUNT;  $Tab; tixPerSec/q1*%COUNT
	Print #1,  "Add";         $Tab; q2;   $Tab; q2/%COUNT;  $Tab; tixPerSec/q2*%COUNT
	Print #1,  "Item";        $Tab; q3;   $Tab; q3/%COUNT;  $Tab; tixPerSec/q3*%COUNT
	Print #1,  "Indexof";     $Tab; q4;   $Tab; q4/%COUNT;  $Tab; tixPerSec/q4*%COUNT
	Print #1,  "Contains";    $Tab; q5;   $Tab; q5/%COUNT;  $Tab; tixPerSec/q5*%COUNT
	Print #1,  "RemoveAt";    $Tab; q6;   $Tab; q6/%COUNT;  $Tab; tixPerSec/q6*%COUNT
	Print #1,  "Add";         $Tab; q7;   $Tab; q7/%COUNT;  $Tab; tixPerSec/q7*%COUNT
	Print #1,  "Clear";       $Tab; q8;   $Tab; q8/%COUNT;  $Tab; tixPerSec/q8*%COUNT
	Print #1,  "Release";     $Tab; q9;   $Tab; q9/%COUNT;  $Tab; tixPerSec/q9*%COUNT
	Print #1,  "Add";         $Tab; q10;  $Tab;q10/%COUNT;  $Tab; tixPerSec/q10*%COUNT
	Print #1,  "Remove";      $Tab; q11;  $Tab; q11/%COUNT; $Tab; tixPerSec/q11*%COUNT
	Print #1,  "Release";     $Tab; q12;  $Tab; q12/%COUNT; $Tab; tixPerSec/q12*%COUNT
	Print #1,  "Total";       $Tab; tot
	Print #1,  "Elapsed";     $Tab; e-s
	Print #1,  "Tix/Sec";     $Tab; (tot) / (e-s)
	Print #1,  "Tests";       $Tab; tests
	Print #1,  "Ops/Sec";     $Tab; (%COUNT*tests) / (e-s)
	Close #1
End Sub
