#Compiler PBWin 10, PBCC 6
#Compile Exe
#Dim All
#If %Def( %PB_CC32 )
#Console Off
#EndIf

#Include "..\bag.inc"
#Include "..\console.inc"

Function PBMain () As Long
	Local bag As tBag Ptr                   ' The allocated bag we'll be filling

	ConInit
	ConCls 10, 0

	Bag_Alloc bag, %tBagTypes.eDWord        ' Initialize the allocated bag to hold DWords ("dynamic string" handles)

	AddValues @bag, 0                       ' Fill the array with 0-9
	AddValues @bag, 100                     ' Fill the array with 100-109
	AddValues @bag, 1000                    ' Fill the array with 1000-1009

	ShowValues @bag                         ' Display the values

	RemoveAllValues @bag                    ' Remove all the values from the bag
	Bag_Free bag                            ' Free the allocated bag
	ConClose -1
End Function

'================================================
' "high-level" value functions
'================================================
Sub AddValues( bag As tBag, ByVal start As Long )
	Local i As Long
	For i=0 To 9
		Bag_Add bag, _                        ' Create a "dynamic" StringZ
						MakeString( Format$( i+start ) )
	Next
End Sub

Sub RemoveAllValues( bag As tBag )
	Local i As Long
	Local vHndl As Dword Ptr
	For i=0 To Bag_MaxEntry( bag )-1        ' Loop through all the possible entries (even deleted)
		Bag_Item bag, i, vHndl                ' Grab the item
		If vHndl Then                         ' If the item wasn't deleted
			FreeString @vHndl                   ' Free the string
			Bag_RemoveAt bag, i                 ' Remove the entry from the bag
		End If
	Next
End Sub

Sub ShowValues( bag As tBag )
	Local i As Long
	Local vHndl As Dword Ptr

	For i=0 To Bag_MaxEntry( bag )-1        ' Loop through all the possible entries (even deleted)
		Bag_Item bag, i, vHndl                ' Grab the item
		If vHndl Then                         ' If it was't deleted
			ConWriteln GetString( @vHndl )      ' Display string
		End If
	Next
End Sub

'================================================
' "Low level" Dynamic String functions
'================================================
Function MakeString( value As String ) As Dword
	Local vHndl, u As Dword
	Local sp As StringZ Ptr

	GlobalMem Alloc Len(value)+1 To vHndl   ' Allocate memory
	GlobalMem Lock vHndl To sp              ' Lock allocated memory returning a stringZ pointer
	@sp = value                             ' Assign the StringZ variable from the array
	GlobalMem UnLock vHndl To u             ' Unlock the memory
	Function = vHndl                        ' Return memory pointer
End Function

Sub FreeString( ByVal vHndl As Dword )
	Local v As Dword
	If vHndl Then                           ' if it wasn't deleted
		GlobalMem Free vHndl To v             ' Free the memory
	End If
End Sub

Function GetString( ByVal vHndl As Dword ) As String
	Local u As Dword
	Local sp As StringZ Ptr
	Local v As String
	GlobalMem Lock vHndl To sp              ' Lock allocated memory returning a stringZ pointer
	v = @sp                                 ' Capture the string
	GlobalMem UnLock vHndl To u             ' Unlock the memory
	Function = v                            ' Return the value
End Function
