#Compiler PBWin 10, PBCC 6
#Compile Exe
#Dim All
#If %Def( %PB_CC32 )
#Console Off
#EndIf

#Include "..\bag.inc"
#Include "..\console.inc"

Function PBMain () As Long
	Local bag As tBag                   ' The bag we'll be filling
	Local values() As StringZ*32        ' The array of values to add to the bag
	ReDim values(9)

	ConInit
	ConCls 11, 0

	Bag_Init bag, %tBagTypes.eDWord     ' Initialize the bag to hold DWords (memory handles)

	Call BuildValues( values(), 0 )     ' Fill the array with 0-9
	GetMem bag, values()                ' Add them to the bag

	Call BuildValues( values(), 100 )   ' Fill the array with 100-109
	GetMem bag, values()                ' Add them to the bag

	Call BuildValues( values(), 1000 )  ' Fill the array with 1000-1009
	GetMem bag, values()                ' Add them to the bag

	ShowMem bag                         ' Display the values

	FreeMem bag                         ' Free the memory in the bag
	Bag_Release bag                     ' Free the bag memory
	ConClose -1
End Function

Sub BuildValues( values() As StringZ*32, ByVal start As Long )
	Local i As Long
	For i=0 To 9
		values(i) = Format$( i+start )    ' Stick a number in the array
	Next
End Sub

Sub GetMem( bag As tBag, values() As StringZ*32 )
	Local vHndl As Dword
	Local i, u As Long
	Local sp As StringZ Ptr

	' Allocate some memory
	For i=0 To 9
		GlobalMem Alloc 32 To vHndl       ' Allocate memory
		GlobalMem Lock vHndl To sp        ' Lock allocated memory returning a stringZ pointer
		@sp = values(i)                   ' Assign the StringZ variable from the array
		GlobalMem UnLock vHndl To u       ' Unlock the memory
		Bag_Add bag, ByRef vHndl          ' Add the hangle to the bag
	Next
End Sub

Sub FreeMem( bag As tBag )
	Local i As Long
	Local vHndl As Dword Ptr
	Local v As Dword

	For i=0 To Bag_MaxEntry( bag )-1    ' Loop through all the possible entries (even deleted)
		Bag_Item bag, i, vHndl            ' Grab the item
		If vHndl Then                     ' If the item wasn't deleted
			Bag_RemoveAt bag, i             ' Remove the item from the bag
			GlobalMem Free @vHndl To v      ' Free the memory
		End If
	Next
End Sub

Sub ShowMem( bag As tBag )
	Local i, u As Long
	Local vHndl As Dword Ptr
	Local sp As StringZ Ptr
	Local s As String

	For i=0 To Bag_MaxEntry( bag )-1    ' Loop through all the possible entries (even deleted)
		Bag_Item bag, i, vHndl            ' Grab the item
		If vHndl Then                     ' If it was't deleted
			GlobalMem Lock @vHndl To sp     ' Lock the memory
			s = @sp
			ConWriteln s
			GlobalMem UnLock @vHndl To u    ' Unlock the memory
		End If
	Next
End Sub
