#Compiler PBWin 10, PBCC 6
#Compile Exe
#Dim All
#If %Def( %PB_CC32 )
#Console Off
#EndIf

#Include "..\bag.inc"
#Include "..\console.inc"

Type Customers
	Code As StringZ*6                               ' Key to access the customer
	Name As StringZ*40                              ' Customers name
End Type

Function PBMain () As Long
	Local bag As tBag
	Local hCust, recId As Long

	ConInit
	ConCls 14, 0

	Bag_Init bag, %tBagTypes.eStringZ, _            ' Initialize the bag
						CodePtr( caseInsensitiveAscii ), 6

	hCust = FreeFile                                ' Get a file handle
	Open "recs.dat" _                               ' Open the file
		For Random    _
		As #hCust     _
		Len = SizeOf( Customers )

	BuildLookup hCust, bag                          ' Build the lookup

	ConWriteln GetRec( bag, hCust, "tomsp" )        ' Retrieve by key
	ConWriteln GetRec( bag, hCust, "Chops" )        ' Retrieve by key
	ConWriteln GetRec( bag, hCust, "LoNeP" )        ' Retrieve by key

	Bag_Release bag                                 ' Release the memory allocated by the bag
	ConClose -1
End Function

Function GetRec( bag As tBag, ByVal fileNumber As Long, ByVal customerCode As String ) As String
	Local rec As Customers
	Local recId As Long
	Local value As StringZ*6

	value = customerCode                            ' Make the key a StringZ
	recId = Bag_IndexOf( bag, ByRef value ) + 1     ' Get the record id of the key (indexes are 0-n-1, records are 1 to n)
	If recId>0 Then                                 ' If the record was found
		Get #fileNumber, recId, rec                   ' Get the record
		Function = rec.Code + ": " + rec.Name         ' Return it's contents
	Else
		Function = "(not found)"                      ' Indicate record wasn't found
	End If
End Function

Sub BuildLookup( ByVal ff As Long, bag As tBag )
	Local rec As Customers
	Local i As Long

	For i=1 To Lof(#ff)\SizeOf(Customers)           ' Loop through all records
		Get #ff, i, rec                               ' Get a record
		Bag_Add bag, ByRef rec.Code                   ' Add the code to the bag
	Next
End Sub
